Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members Related Pages

# FileListC Class Reference

File list class. More...

`#include <FileListC.h>`

Inheritance diagram for FileListC:

List of all members.

## Public Member Functions
virtual Edit::DataBlockI * | create ()
| Create new file list.
virtual Edit::DataBlockI * | create (Edit::EditableI *pOriginal)
| Creates new file list(used internally), see Edit::EditableI::create().
virtual void | copy (Edit::EditableI *pEditable)
| Deep copy from a data block, see Edit::DataBlockI::copy().
virtual void | restore (Edit::EditableI *pEditable)
| Shallow copy from a editable, see Edit::EditableI::restore().
virtual FileHandleC * | add_file (ImportableI *pImportable, FileHandleC *pFolder)
| Loads a file and adds it to the list.
virtual FileHandleC * | add_folder (const char *szName, FileHandleC *pFolder)
virtual PajaTypes::uint32 | get_file_count ()
| Returns number of files in the list.
virtual void | reload_file (PajaTypes::uint32 ui32Index, ImportInterfaceC *pIface)
| Reloads a file already in the list.
virtual void | replace_file (PajaTypes::uint32 ui32Index, const char *szName, ImportInterfaceC *pIface)
| Replaces a file inthe list with another file .
virtual FileHandleC * | get_file (PajaTypes::uint32 ui32Index)
| Returns the file at given index.
virtual FileHandleC * | get_file (const char *szName, const PluginClass::SuperClassIdC &rSuperFilter, const PluginClass::ClassIdC &rClassFilter)
| Returns the file with given name.
virtual FileHandleC * | get_equal_file (ImportableI *pImportable)
| Returns equal file if exists.
virtual void | del_file (PajaTypes::uint32 ui32Index)
| Deletes the file at given index.
virtual void | del_file (FileHandleC *pHandle)
| Deletes the file at given handle.
virtual bool | prompt_properties (PajaTypes::uint32 ui32Index, PajaSystem::DeviceContextC *pContext, PajaSystem::TimeContextC *pTimeContext, ImportInterfaceC *pIface)
| Prompts file properties.
virtual PajaTypes::uint32 | save (FileIO::SaveC *pSave)
| Save editable to a Demopaja output stream.
virtual PajaTypes::uint32 | load (FileIO::LoadC *pLoad)
| Load editable from a Demopaja input stream.
## Static Public Member Functions
FileListC * | create_new ()
| Create new file list.
## Protected Member Functions
| FileListC ()
| Default constructor.
| FileListC (Edit::EditableI *pOriginal)
| Default constructor with reference to the original.
virtual | ~FileListC ()
| Default destructor.
void | clear_list ()
| Clears the internal file list, but doesn't delete the content.

## Detailed Description

File list class.

File list class manages the imported files. It checks for duplicates enables to load, reload, replace, and delete importable files. Changes made to file list are also undoable. This class is used internally.

This class is implemented by the system.

## Constructor & Destructor Documentation

FileListC | ( |  | ) | `[protected]`

| Default constructor.

FileListC | ( | Edit::EditableI * | pOriginal | ) | `[protected]`

| Default constructor with reference to the original.

virtual ~FileListC | ( |  | ) | `[protected, virtual]`

| Default destructor.

## Member Function Documentation

virtual FileHandleC* add_file | ( | ImportableI * | pImportable,
|  | FileHandleC * | pFolder
| ) | `[virtual]`

| Loads a file and adds it to the list.

void clear_list | ( |  | ) | `[protected]`

| Clears the internal file list, but doesn't delete the content.

virtual void copy | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Deep copy from a data block, see Edit::DataBlockI::copy(). Implements EditableI.

virtual Edit::DataBlockI* create | ( | Edit::EditableI * | pOriginal | ) | `[virtual]`

| Creates new file list(used internally), see Edit::EditableI::create(). Implements EditableI.

virtual Edit::DataBlockI* create | ( |  | ) | `[virtual]`

| Create new file list. Implements EditableI.

FileListC* create_new | ( |  | ) | `[static]`

| Create new file list.

virtual void del_file | ( | FileHandleC * | pHandle | ) | `[virtual]`

| Deletes the file at given handle.

virtual void del_file | ( | PajaTypes::uint32 | ui32Index | ) | `[virtual]`

| Deletes the file at given index.

virtual FileHandleC* get_equal_file | ( | ImportableI * | pImportable | ) | `[virtual]`

| Returns equal file if exists.

virtual FileHandleC* get_file | ( | const char * | szName,
|  | const PluginClass::SuperClassIdC & | rSuperFilter,
|  | const PluginClass::ClassIdC & | rClassFilter
| ) | `[virtual]`

| Returns the file with given name.

virtual FileHandleC* get_file | ( | PajaTypes::uint32 | ui32Index | ) | `[virtual]`

| Returns the file at given index.

virtual PajaTypes::uint32 get_file_count | ( |  | ) | `[virtual]`

| Returns number of files in the list.

virtual PajaTypes::uint32 load | ( | FileIO::LoadC * | pLoad | ) | `[virtual]`

| Load editable from a Demopaja input stream. Implements EditableI.

virtual bool prompt_properties | ( | PajaTypes::uint32 | ui32Index,
|  | PajaSystem::DeviceContextC * | pContext,
|  | PajaSystem::TimeContextC * | pTimeContext,
|  | ImportInterfaceC * | pIface
| ) | `[virtual]`

| Prompts file properties.

virtual void reload_file | ( | PajaTypes::uint32 | ui32Index,
|  | ImportInterfaceC * | pIface
| ) | `[virtual]`

| Reloads a file already in the list. This method will create a new instace of the same plugin class and attach it to the file handle. The old instance is not used. The caller of this method is responsible to update every parameter which has the filehandle of this importable points. The Demopaja GUI does that every time the reload is requested.

virtual void replace_file | ( | PajaTypes::uint32 | ui32Index,
|  | const char * | szName,
|  | ImportInterfaceC * | pIface
| ) | `[virtual]`

| Replaces a file inthe list with another file . This method will create a new instace of the same plugin class and attach it to the file handle. The old instance is not used. The caller of this method is responsible to update every parameter which has the filehandle of this importable points. The Demopaja GUI does that every time the replace is requested.

virtual void restore | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Shallow copy from a editable, see Edit::EditableI::restore(). Implements EditableI.

virtual PajaTypes::uint32 save | ( | FileIO::SaveC * | pSave | ) | `[virtual]`

| Save editable to a Demopaja output stream. Implements EditableI.